\documentclass{beamer}

\input{config/use}
\input{config/beamer}

\title[Building AI strategy for Wizard game with NN and RL]{Building AI strategy for Wizard game\\with neural networks and\\reinforcement learning}
\author[D. Missal, B. Ashirmatov, M. Enayati]{Daniel~Missal\\Bakhodir~Ashirmatov\\Mahdi~Enayati}
\date{07.07.2018}
\institute{Faculty of Physics\\University~of~Göttingen}
\titlegraphic{\vspace{-5pt}\includegraphics[width = 1.7cm]{images/Goettingen.png}}

\begin{document}

\maketitle

\section*{Plan}

\begin{frame}{Plan}
  \tableofcontents
\end{frame}

\section{Motivation}

\begin{frame}{Motivation}
  \begin{minipage}[c]{0.5\textwidth}
    \centering
    \vspace{10pt}
    \includegraphics[width = 2.5cm]{images/amigo.jpg}

    \vspace{10pt}
    \scriptsize{wwww.amazon.com/Wizard-Amigo-6900-
    Card-Language/dp/B01N074CO8}
  \end{minipage}
  \begin{minipage}[c]{0.49\textwidth}
    \centering
    \vspace{-5pt}
    \includegraphics[width = 5.5cm]{images/cards1.png}

    \includegraphics[width = 5.5cm]{images/cards2.png}
  \end{minipage}
\end{frame}

\section{Wizard game}

\begin{frame}{Wizard game}
  \blue{Wizard game}
  \begin{itemize}
    \item Created by \blue{Ken Fisher} in Toronto, Ontario in 1984
    \item Published by \blue{AMIGO Spiel + Freizeit GmbH} in Germany in 1996
    \item Designed for \blue{three to six players}
  \end{itemize}
\end{frame}

\subsection{Trick}

\begin{frame}{Wizard game}
  \blue{Trick}
  \begin{itemize}
    \item Each player plays \blue{1 card}
    \item \blue{The strengths} of the cards are \blue{compared}
    \item The player who played \blue{the strongest} card \blue{wins} the trick
  \end{itemize}
\end{frame}

\subsection{Round}

\begin{frame}{Wizard game}
  \blue{Round}
  \begin{itemize}
    \item \blue{Bidding phase:} \blue{predict} the \blue{number of tricks} to \blue{win}
    \item \blue{Trick-taking phase:} try to \blue{win precisely} a predicted \blue{number of tricks}
  \end{itemize}
\end{frame}

\subsection{Bidding phase}

\begin{frame}{Wizard game}
  \blue{Bidding phase}
  \begin{itemize}
    \item Only \blue{correct} bidding \blue{increases} the points
    \item The \blue{closer} to bidding - the \blue{better}
  \end{itemize}
  \blue{$$gain = \begin{cases} 20 + 10 \times bids & \textcolor{black}{\text{ if }} won\_tricks = bids\\
								               -10 \times |won\_tricks - bids| & \textcolor{black}{\text{ else }}
								 \end{cases}$$}
  \begin{itemize}
    \item \blue{Important} to bid \blue{right}, \blue{not} neccessary \blue{high}
  \end{itemize}
\end{frame}

\subsection{Cards}

\begin{frame}{Wizard game}
  \vspace{10pt}
  \blue{Cards}
  \begin{itemize}
    \item \alert{Red: 1..13}
    \item \textcolor[rgb]{0.8, 0.8, 0}{Yellow: 1..13}
  	\item \blue{Blue: 1..13}
  	\item \textcolor[rgb]{0, 0.5, 0}{Green: 1..13}
  	\item \textbf{White: 4 wizards and 4 jesters}
  \end{itemize}
  \centering

  \vspace{10pt}
  \includegraphics[width = 11cm]{images/cards.png}
\end{frame}

\subsection{Trick-taking phase}

\begin{frame}{Wizard game}
  \vspace{10pt}
  \blue{Trick-taking phase - Determining the trump color}
  \begin{itemize}
    \item \blue{$n\_cards = n\_round$}
    \item \blue{Trump} is \blue{popped} from the \blue{deck}
  \end{itemize}
  \centering

  \vspace{10pt}
  \includegraphics[width = 6cm]{images/game_trump.png}

  \blue{Three players} start \blue{round 5} with \textcolor[rgb]{0, 0.5, 0}{green trump} color
\end{frame}

\begin{frame}{Wizard game}
  \vspace{10pt}
  \blue{Trick-taking phase - Leading color}
  \begin{itemize}
    \item \blue{First color} played in a trick must get \blue{served}, if \blue{possible}
  	\item	\blue{White cards} are always \blue{allowed}
  \end{itemize}
  \centering

  \vspace{10pt}
  \includegraphics[width = 5.5cm]{images/game_leading.png}

  Both \blue{player 2} and \blue{player 3} did \blue{not} have a \alert{red} card
\end{frame}

\begin{frame}{Wizard game}
  \vspace{5pt}
  \blue{Trick-taking phase - Comparing the cards by strength}
  \begin{enumerate}
    \item \blue{Sort} cards by \blue{type} (\blue{Wizards} \blue{$>$} \blue{Trump} color cards \blue{$>$} \blue{Leading} color cards \blue{$>$} Cards of \blue{other non-white} colors  \blue{$>$} \blue{Jesters})
  	\item \blue{Sort} each type by \blue{number}
  \end{enumerate}
  \centering

  \vspace{10pt}
  \includegraphics[width = 5cm]{images/game_card_strength.png}

  \blue{Player 5 won} the trick by playing the \textbf{wizard}
\end{frame}

\section{Data}

\subsection{Project goals}

\begin{frame}{Project Goal 1 of 2}
  Assumptions:
  \begin{itemize}
    \item $p =$ Position in the trick-taking-phase
    \item $M(p) =$ Set of all feasible moves in $p$
    \item $m =$ Feasible move $\in M(p)$
    \item $g(m,p) =$ Expected gain of points at end of round, if $m$ is played in $p$
  \end{itemize}
  \[
   (m,p) \mapsto g(m,p)
  \]
  Goal:
  \begin{itemize}
    \item Predict g(m,p) given (m,p) using a neural network
  \end{itemize}
  AI strategy:
  \begin{itemize}
    \item Always choose move with highest expected gain
  \end{itemize}
\end{frame}

\begin{frame}{Project Goal 2 of 2}
  \blue{Developing an evolution cycle for player and learning data}
  \begin{itemize}
    \item Use \blue{game observations} to train \blue{generation 0} of neural network
    \item Repeat for \blue{$i = 0, 1, ...$}
    \begin{itemize}
      \item Create \blue{game observations} with \blue{generation $i$} of neural network
      \item Use \blue{game observations} of \blue{generation $i$} to train \blue{generation $i + 1$}
    \end{itemize}
  \end{itemize}
\end{frame}

\subsection{Features}

\begin{frame}{Features 1 to 10 of 41}
 \begin{tabular}{l l l}
  $x_1$ & Player index & Players are numbered from 0 to $n - 1$ \\
  $x_2$ &  &  \\
  $x_3$ &  &  \\
  $x_4$ &  &  \\
  $x_5$ &  &  \\
  $x_6$ &  &  \\
  $x_7$ &  &  \\
  $x_8$ &  &  \\
  $x_9$ &  &  \\
  $x_{10}$ &  &  \\
 \end{tabular}
\end{frame}
 
\subsection{Static Algorithms}

\begin{frame}{Static algorithms as data generators}
  Situation:
  \begin{itemize}
    \item For ML we will need a lot of data.
  \end{itemize}
  Problem:
  \begin{itemize}
    \item Human players takes too long
    \item Later we might want to change the data features we collected during the game
  \end{itemize}
  Solution:
  \begin{itemize}
    \item Create non-machine-learning (static) playing algorithms (\blue{static bots}).
  \end{itemize}
  Advantage:
  \begin{itemize}
    \item Bots can play on their own
    \item During development we learn about features
  \end{itemize}
\end{frame}

\section{AI strategy}

\begin{frame}{AI strategy}
  \blue{Game state observations}
  \begin{itemize}
    \item Bidding phase - \blue{$(0, x_1, ..., x_{41})$}
    \item Trick-taking phase - \blue{$(1, x_1, ..., x_{41})$}
  \end{itemize}
  \blue{Goal}
  \begin{itemize}
    \item Build an \blue{AI strategy} to choose \blue{move} in current \blue{game state}
  \end{itemize}
\end{frame}

\begin{frame}{AI strategy}
  \blue{AI strategy}
  \begin{itemize}
    \item For every \blue{feasible move $m \in M_s$} in current \blue{game state $s$}
    \begin{itemize}
      \item Calculate \blue{$gain(s, m)$}
    \end{itemize}
    \item Choose \blue{best} move \blue{$\operatornamewithlimits{argmax}\limits_{m \in M_s}{gain(s, m)}$}
  \end{itemize}
  \blue{Idea}
  \begin{itemize}
    \item Build \blue{one neural network} for predicting gain in \blue{both phases!}
  \end{itemize}
  \blue{Advantage}
  \begin{itemize}
    \item Avoid \blue{aggressive bidding} with \blue{safe play} and \blue{vice versa}
  \end{itemize}
\end{frame}

\subsection{Neural network}

\begin{frame}{Neural network}
  \blue{Structure}
  \begin{itemize}
    \item \blue{1 input layer} with \blue{42 neurons}
    \item \blue{4 hidden layers} with \blue{80, 40, 20 and 10 neurons}
    \item \blue{1 output layer} with \blue{1 neuron}
    \item \blue{ReLU} activation function
    \item \blue{Adam} optimiser
    \item \blue{Normal} initialiser
    \item \blue{3 epochs}
  \end{itemize}
  \blue{Training}
  \begin{itemize}
    \item Use \blue{observations} from \blue{5000 games}
  \end{itemize}
\end{frame}

\begin{frame}{AI strategy with NN}
  \blue{Number of layers vs average points (5000 games)}

  \vspace{5pt}
  \begin{minipage}[c]{0.5\textwidth}
      \centering
	\includegraphics[width = 4.5cm]{images/NN_1_avg_points.png}

    \vspace{10pt}
	\includegraphics[width = 4.5cm]{images/NN_3_avg_points.png}
  \end{minipage}
  \begin{minipage}[c]{0.49\textwidth}
      \centering
    \includegraphics[width = 4.5cm]{images/NN_2_avg_points.png}

    \vspace{10pt}
    \includegraphics[width = 4.5cm]{images/NN_4_avg_points.png}
  \end{minipage}
  \centering

  \vspace{5pt}
  \blue{uniform\_bot} was \blue{stable} at \blue{$[-570, -600]$}
\end{frame}

\begin{frame}{AI strategy with NN}
    \blue{Number of layers vs success rate (5000 games)}

    \vspace{5pt}
    \begin{minipage}[c]{0.5\textwidth}
        \centering
        \includegraphics[width = 4.5cm]{images/NN_1_success_rate.png}

        \vspace{10pt}
        \includegraphics[width = 4.5cm]{images/NN_3_success_rate.png}
    \end{minipage}
    \begin{minipage}[c]{0.49\textwidth}
        \centering
        \includegraphics[width = 4.5cm]{images/NN_2_success_rate.png}

        \vspace{10pt}
        \includegraphics[width = 4.5cm]{images/NN_4_success_rate.png}
    \end{minipage}
    \centering

    \vspace{5pt}
    \blue{uniform\_bot} was \blue{stable} at \blue{$0\%$}
\end{frame}

\begin{frame}{AI strategy with NN}
  \blue{Training size vs average points and success rate (1000 games)}

  \vspace{15pt}
  \begin{minipage}[c]{0.5\textwidth}
      \centering
      \includegraphics[width = 6cm]{images/NN_training_avg_points.png}
  \end{minipage}
  \begin{minipage}[c]{0.49\textwidth}
      \centering
      \includegraphics[width = 6cm]{images/NN_training_success_rate.png}
  \end{minipage}
  \centering

  \vspace{15pt}
  \blue{uniform\_bot} was \blue{stable} at \blue{$[-570, -600]$} and \blue{$0\%$}
\end{frame}

\begin{frame}{AI strategy with NN}
  \blue{Disadvantages}
  \begin{itemize}
    \item \blue{Supervised learning} needs \blue{a lot of data} at once
    \item \blue{Supervised learning} is \blue{static} after training
  \end{itemize}
  \blue{Idea}
  \begin{itemize}
    \item Use \blue{reinforcement learning!}
  \end{itemize}
  \blue{Advantage}
  \begin{itemize}
    \item Resistant to \blue{changing opponent strategies}
  \end{itemize}
\end{frame}

\subsection{Reinforcement learning}

\begin{frame}{Reinforcement learning}
  \centering
  \includegraphics[width = 10cm]{images/RL.png}

  \vspace{15pt}
  \scriptsize{web.stanford.edu/class/cs234/index.html}
\end{frame}

\begin{frame}{Reinforcement learning}
  \blue{Reinforcement learning}
  \begin{itemize}
    \item Use \blue{game observations} to train \blue{generation 0} of AI strategy
    \item Repeat for \blue{$i = 0, 1, ...$}
    \begin{itemize}
      \item Create \blue{game observations} with \blue{generation $i$} of AI strategy
      \item Initialise \blue{generation $i + 1$} with \blue{generation $i$}
      \item Use \blue{game observations} of \blue{generation $i$} to train \blue{generation $i + 1$}
    \end{itemize}
  \end{itemize}
  \blue{Training}
  \begin{itemize}
    \item Use \blue{observations} from \blue{5000 games} per iteration
  \end{itemize}
\end{frame}

\begin{frame}{AI strategy with NN and RL}
  \blue{Training size}
  \begin{itemize}
    \item TODO dependency between training size and gain and generations
  \end{itemize}
\end{frame}

\begin{frame}{AI strategy with NN and RL}
  \blue{Training size}
  \begin{itemize}
    \item TODO dependency between training size and success rate and generations
  \end{itemize}
\end{frame}

\begin{frame}{AI strategy with NN and RL}
  \blue{Training size}
  \begin{itemize}
    \item TODO AI strategies against each other
  \end{itemize}
\end{frame}

\section{Discussion}

\begin{frame}{Discussion}
  \blue{Further research}
  \begin{itemize}
    \item \blue{Recurrent neural networks} have \blue{longer memory}
    \item \blue{Aggressive reinforcement learning} helps to get out of \blue{local optima}
    \item \blue{Game observations} can be updated only \blue{partly}
    \item \blue{Complex static strategies} improve \blue{AI strategy}
  \end{itemize}
\end{frame}

\section{Conclusion}

\begin{frame}{Conclusion}
\end{frame}

\begin{frame}{Questions?}
  \centering
  \includegraphics[width = 9cm]{images/ai.jpeg}

  \vspace{10pt}
  \scriptsize{www.peoplebank.com.au/blog/2017/11/all-the-ethical-questions-
  surrounding-ai-and-robot-employees}
\end{frame}

\end{document}
